#include<windows.h>
#include "cameradll.h"

//Functions Pointers

HANDLE (WINAPI *lpfnOpenCamera)(long *lTypeCode,char *szPortName);
BOOL   (WINAPI *lpfnCloseCamera)(HANDLE hCamera);
long   (WINAPI *lpfnSetConfigParam)(HANDLE hCamera,long wParam,long lParam,short Des);
long   (WINAPI *lpfnGetConfigParam)(HANDLE hCamera,long wParam,void *lParam,short Des);
long   (WINAPI *lpfnRecallParam)(HANDLE hCamera);
long   (WINAPI *lpfnMemorizeParam)(HANDLE hCamera);
BOOL   (WINAPI *lpfnSaveConfigFile)(HANDLE hCamera,LPSTR lpConfigFile);
BOOL   (WINAPI *lpfnLoadConfigFile)(HANDLE hCamera,LPSTR lpConfigFile);
long   (WINAPI *lpfnGetLastError)();
BOOL   (WINAPI *lpfnGetLinkStatus)(HANDLE hCamera);
BOOL   (WINAPI *lpfnCalExposeRange)(HANDLE hCamera,long *expose_min,long *expose_max);
double (WINAPI *lpfnCalFrameRate)(HANDLE hCamera,long Index);
long   (WINAPI *lpfnCalExposeTime)(HANDLE hCamera,long expose_line);
long   (WINAPI *lpfnCalExposeLine)(HANDLE hCamera,long expose_time);
long   (WINAPI *lpfnGetTypeCode)(HANDLE hCamera,LPSTR* lpCameraName);
long   (WINAPI *lpfnGetVerCode)(HANDLE hCamera,LPSTR lpCameraName);
long   (WINAPI *lpfnGetDriverVer)(HANDLE hCamera,LPSTR lpCameraName);


static int		iLoadNum=0;
static HANDLE	hDLLDrv;



BOOL LoadOkCamDll(BOOL bCount)
{
	if(!hDLLDrv)
		hDLLDrv=LoadLibrary(TEXT("okcamera.dll"));

	if(!hDLLDrv) //not found
		return FALSE;

	if(iLoadNum==0)
	{
		(FARPROC )lpfnOpenCamera=GetProcAddress(hDLLDrv,"okCamOpenCamera");
		(FARPROC )lpfnCloseCamera=GetProcAddress(hDLLDrv,"okCamCloseCamera");
		(FARPROC )lpfnSetConfigParam=GetProcAddress(hDLLDrv,"okCamSetConfigParam");
		(FARPROC )lpfnGetConfigParam=GetProcAddress(hDLLDrv,"okCamGetConfigParam");
		(FARPROC )lpfnRecallParam=GetProcAddress(hDLLDrv,"okCamRecallParam");
		(FARPROC )lpfnMemorizeParam=GetProcAddress(hDLLDrv,"okCamMemorizeParam");
		(FARPROC )lpfnSaveConfigFile=GetProcAddress(hDLLDrv,"okCamSaveConfigFile");
		(FARPROC )lpfnLoadConfigFile=GetProcAddress(hDLLDrv,"okCamLoadConfigFile");
		(FARPROC )lpfnGetLastError=GetProcAddress(hDLLDrv,"okCamGetLastError");
		(FARPROC )lpfnGetLinkStatus=GetProcAddress(hDLLDrv,"okCamGetLinkStatus");
		(FARPROC )lpfnCalExposeRange=GetProcAddress(hDLLDrv,"okCamCalExposeRange");
		(FARPROC )lpfnCalFrameRate=GetProcAddress(hDLLDrv,"okCamCalFrameRate");
		(FARPROC )lpfnCalExposeTime=GetProcAddress(hDLLDrv,"okCamCalExposeTime");
		(FARPROC )lpfnCalExposeLine=GetProcAddress(hDLLDrv,"okCamCalExposeLine");
		(FARPROC )lpfnGetTypeCode=GetProcAddress(hDLLDrv,"okCamGetTypeCode");
		(FARPROC )lpfnGetVerCode=GetProcAddress(hDLLDrv,"okCamGetVerCode");
		(FARPROC )lpfnGetDriverVer=GetProcAddress(hDLLDrv,"okCamGetDriverVer");
	}

	if(bCount || (iLoadNum==0) )
		iLoadNum++;

	return TRUE;
}

FreeOkCamDll()
{
	iLoadNum--;
	if(iLoadNum<=0) 
	{
		FreeLibrary(hDLLDrv);
		hDLLDrv=0;
	}
	return 1;
}

FARPROC GetProcPointer(LPSTR lpszName)
{
	if(!hDLLDrv)
		hDLLDrv=LoadLibrary("okcamera.dll");

	return GetProcAddress(hDLLDrv,lpszName);
}

HANDLE WINAPI okCamOpenCamera(long *lTypeCode,char *szPortName)
{
	LoadOkCamDll(1);
	return lpfnOpenCamera(lTypeCode,szPortName);
}

BOOL  WINAPI okCamCloseCamera(HANDLE hCamera)
{
	BOOL	ret=0;

	if(hDLLDrv)
		ret=lpfnCloseCamera(hCamera);

	if(ret)
		FreeOkCamDll();

	return ret;
}


long  WINAPI okCamSetConfigParam(HANDLE hCamera,long wParam,long lParam,short Des)
{
	return lpfnSetConfigParam(hCamera,wParam,lParam,Des);
}

long  WINAPI okCamGetConfigParam(HANDLE hCamera,long wParam,void *lParam,short Des)
{
	return lpfnGetConfigParam(hCamera,wParam,lParam,Des);
}

long  WINAPI okCamRecallParam(HANDLE hCamera)
{
	return lpfnRecallParam(hCamera);
}

long  WINAPI okCamMemorizeParam(HANDLE hCamera)
{
	return lpfnMemorizeParam(hCamera);
}

BOOL  WINAPI okCamSaveConfigFile(HANDLE hCamera,LPSTR lpConfigFile)
{	
	return lpfnSaveConfigFile(hCamera,lpConfigFile);
}

BOOL  WINAPI okCamLoadConfigFile(HANDLE hCamera,LPSTR lpConfigFile)
{
	return lpfnLoadConfigFile(hCamera,lpConfigFile);
}

long  WINAPI okCamGetLastError()
{
	return lpfnGetLastError();
}

BOOL  WINAPI okCamGetLinkStatus(HANDLE hCamera)
{
	return lpfnGetLinkStatus(hCamera);
} 

BOOL WINAPI  okCamCalExposeRange(HANDLE hCamera,long *expose_min,long *expose_max)
{
	return lpfnCalExposeRange(hCamera,expose_min,expose_max);
}

double WINAPI  okCamCalFrameRate(HANDLE hCamera,long Index)
{
	return lpfnCalFrameRate(hCamera,Index);
}

long  WINAPI  okCamCalExposeTime(HANDLE hCamera,long expose_line)
{
	return lpfnCalExposeTime(hCamera,expose_line);
}

long  WINAPI  okCamCalExposeLine(HANDLE hCamera,long expose_time)
{
	return lpfnCalExposeLine(hCamera,expose_time);
}

long  WINAPI okCamGetTypeCode(HANDLE hCamera,LPSTR* lpCameraName)
{
	return lpfnGetTypeCode(hCamera,lpCameraName);
}

long  WINAPI okCamGetVerCode(HANDLE hCamera,LPSTR lpCameraName)
{
	return lpfnGetVerCode(hCamera,lpCameraName);
}

long  WINAPI okCamGetDriverVer(HANDLE hCamera,LPSTR lpCameraName)
{
	return lpfnGetDriverVer(hCamera,lpCameraName);
}